﻿namespace Vibstudio.NetConfigurator.Exceptions
{
    #region Namespaces

    using System;

    using Vibstudio.NetConfigurator.Globalization;

    #endregion

    public sealed class FileNotFoundException : Exception
    {
        #region Ctor(s)

        public FileNotFoundException()
            : base(Labeler.Get.FileNotFoundInDirectory().ToString(), null)
        {
        }

        public FileNotFoundException(string path)
            : base(Labeler.Get.FileNotFoundInDirectory(path).ToString(), null)
        {
        }

        public FileNotFoundException(string file, string path)
            : base(Labeler.Get.FileNotFoundInDirectory(file, path).ToString(), null)
        {
        }

        public FileNotFoundException(string file, string rootPath, string folderName)
            : base(Labeler.Get.FileNotFoundInDirectory(file, rootPath, folderName).ToString(), null)
        {
        }

        #endregion
    }
}