﻿namespace Vibstudio.NetConfigurator.UI.Model
{
    #region Namespaces
    
    using Vibstudio.NetConfigurator.Common;

    #endregion

    public sealed class ResultValidationUrl : IValidatable
    {
        #region Ctor(s)

        public ResultValidationUrl()
        {
        }

        public ResultValidationUrl(string application, string url)
            : this(application, url, true, string.Empty)
        {
        }

        public ResultValidationUrl(string application, string url, bool isValid)
            : this(application, url, isValid, string.Empty)
        {
        }

        public ResultValidationUrl(string application, string url, bool isValid, string message)
        {
            Application = application;
            Url = url;
            IsValid = isValid;
            Message = message;
        }

        #endregion

        #region Public Properties

        public string Application { get; set; }

        public string Url { get; set; }

        public bool IsValid { get; set; }

        public string Message { get; set; }

        #endregion
    }
}