﻿namespace Vibstudio.NetConfigurator.UI.ViewModels
{
    using Vibstudio.NetConfigurator.UI.Common;

    public class ShellViewModel : ViewModelBase
    {
        #region Fields

        private IChildView _childView;

        #endregion

        #region Constuctors

        public ShellViewModel()
        {
            HeaderView = ViewRepository.Get.Header();
            ToolbarView = ViewRepository.Get.Toolbar();
        }

        #endregion

        #region Properties

        public IShellView HeaderView { get; private set; }

        public IShellView ToolbarView { get; private set; }

        public IChildView ChildView
        {
            get { return _childView; }
            set
            {
                _childView = value;
                base.OnPropertyChanged("ChildView");
            }
        }

        #endregion
    }
}